#include <iostream>
#include <fstream>
#include <vector>
#include "stringify.h"

using namespace std;

string rcomp(string s) {

  string r;
  for(int n=s.size()-1;n>=0;n--) {
    if(s[n] == 'A') r += "T";
    if(s[n] == 'T') r += "A";
    if(s[n] == 'G') r += "C";
    if(s[n] == 'C') r += "G";
  }

  return r;
}

int main() {

  cout << "Loading reference" << endl;
  ifstream refin("./reference");
  string ref;
  string reforg;
  refin >> ref;
  refin.close();
  reforg = ref;

  cout << "Loading mutations" << endl;
  ifstream mutsin("./muts");
  vector<int> muts;
  for(;!mutsin.eof();) {
    int loc;
    mutsin >> loc;
    if(!mutsin.eof())
    muts.push_back(loc);
  }

  string refmuts = ref;
  for(int n=0;n<muts.size();n++) {
    refmuts[muts[n]-1] = 'x';
  }

  cout << "Loading primers" << endl;
  ifstream primersin("./primers");
  vector<string> primers;
  for(;!primersin.eof();) {
    string p;
    primersin >> p;
    if(primersin.eof()) break;
    primers.push_back(p);
  }

  cout << "Computing primer locations" << endl;
  vector<int> primer_locations;
  for(int n=0;n<primers.size();n++) {
    bool found=false;
    for(int i=0;i<ref.size();i++) {
      string p = ref.substr(i,primers[n].size());
      if(p == primers[n]) {
        cout << "Primer location F: " << i << endl;;
	primer_locations.push_back(i);
	if(found==true) cout << "ERROR!!!!!!!!!!!!!!!!!!!! Multiple hits" << endl;
	found=true;
	//break;
      }
      if(rcomp(p) == primers[n]) {
        cout << "Primer location R: " << i << endl;;
	primer_locations.push_back(i);
	if(found==true) cout << "ERROR!!!!!!!!!!!!!!!!!!!! Multiple hits" << endl;
	found=true;
	break;
      }
    }
    if(found==false) cout << "Primer location: NOT FOUND" << endl;
  }

  vector<string> primers_marked = primers;
  for(int n=0;n<primer_locations.size();n++) {
    cout << "Primer:" << primers[n] << endl;
    for(int i=0;i<primers[n].size();i++) {
      int pos=primer_locations[n]+i;
      if(refmuts[pos] == 'x') {
        cout << "mutation: " << pos << " " << i << " " << primers[n].size()-i-1 << endl;
	primers_marked[n][i] = 'x';
      }
    }
  }

  cout << "Primer mutations" << endl;
  for(int n=0;n<primers_marked.size();n++) {
    cout << primers_marked[n] << endl;
  }
}
